<script lang="ts">
import Vue from 'vue';
import ParallaxContainer from './parallax-container.vue';

export default Vue.extend({
  name: 'SurveyQuoteCarousel',
  components: { ParallaxContainer },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
    autoSlideInterval: {
      type: Number,
      required: false,
      default: 4000,
    },
  },
  data() {
    return {
      activeImage: 0,
      autoSlideTimeout: null,
      stopSlider: false,
      timeLeft: 0,
      timerInterval: null,
      countdownInterval: 10,
      progressBarWidth: 100 / this.data.quotes.length,
    };
  },
  computed: {
    currentSlide() {
      // eslint-disable-next-line
      this.timeLeft = this.autoSlideInterval;
      return this.activeImage;
    },
    progressBar() {
      return 100 - (this.timeLeft / this.autoSlideInterval) * 100;
    },
  },
  mounted() {
    this.observer = new IntersectionObserver(this.startCarouselHandler, {
      rootMargin: '0px',
      threshold: 0,
    });
    const children = document.querySelector('.survey-quote-carousel');
    this.observer.observe(children);
  },
  beforeDestroy() {
    this.observer.disconnect();
    this.stopTimer();
  },
  methods: {
    startCarouselHandler(entries: any, observer) {
      entries.forEach((entry: any) => {
        const element = entry.target;

        if (entry.isIntersecting) {
          observer.unobserve(element);
          this.startSlides();
        }
      });
    },
    startSlides() {
      if (
        this.autoSlideInterval &&
        this.autoSlideInterval > this.countdownInterval
      ) {
        this.startTimer(this.autoSlideInterval);
        this.timeLeft = this.autoSlideInterval;
        this.startCountdown();
      }
    },
    nextImage() {
      let active = this.activeImage + 1;
      if (active >= this.data.quotes.length) {
        active = 0;
      }
      this.activateSlide(active);
    },
    activateSlide(imageIndex) {
      this.activeImage = imageIndex;
    },
    startTimer(interval) {
      if (interval && interval > 0 && !this.stopSlider) {
        clearTimeout(this.autoSlideTimeout);
        this.autoSlideTimeout = setTimeout(() => {
          this.nextImage();
          this.startTimer(this.autoSlideInterval);
        }, interval);
      }
    },
    stopTimer() {
      clearTimeout(this.autoSlideTimeout);
      this.stopSlider = true;
      clearInterval(this.timerInterval);
    },
    restartTimer() {
      this.stopSlider = false;
      clearInterval(this.timerInterval);
      this.startCountdown();
      this.startTimer(this.timeLeft);
    },
    startCountdown() {
      this.timerInterval = setInterval(() => {
        this.timeLeft -= this.countdownInterval;
        if (this.timeLeft <= 0) {
          this.timeLeft = this.autoSlideInterval;
        }
      }, this.countdownInterval);
    },
  },
});
</script>

<template>
  <div class="survey-quote-carousel">
    <SlpContainer>
      <div
        v-if="data.background"
        class="survey-quote-carousel__background"
        data-aos="zoom-in-up"
        :data-aos-duration="data.aos_duration"
        :data-aos-offset="data.aos_offset"
      >
        <ParallaxContainer :offset="0.02">
          <nuxt-img
            :src="data.background.src"
            :alt="data.background.alt ?? ''"
            loading="lazy"
            format="webp"
            quality="99"
          />
        </ParallaxContainer>
      </div>
      <SlpRow class="slp-align-items-center">
        <SlpColumn :cols="9" class="">
          <div class="survey-quote-carousel__slide">
            <transition name="slide-fade" mode="out-in" tag="div">
              <div
                :key="currentSlide"
                @mouseover="stopTimer"
                @mouseleave="restartTimer"
              >
                <SlpTypography variant="heading3" tag="div">
                  <div v-html="data.quotes[currentSlide].text"></div>
                </SlpTypography>
                <SlpTypography
                  variant="body1-bold"
                  tag="p"
                  class="survey-quote-carousel__author slp-mt-24"
                >
                  - {{ data.quotes[currentSlide].author }}</SlpTypography
                >
              </div>
            </transition>
            <div
              v-if="autoSlideInterval"
              class="survey-quote-carousel__progressbar-container"
            >
              <div
                v-for="(quote, index) in data.quotes"
                :key="quote.text"
                class="survey-quote-carousel__progressbar"
                :style="{ width: progressBarWidth + '%' }"
              >
                <div
                  :style="{ width: progressBar + '%' }"
                  :class="{ active: currentSlide == index }"
                  @click="activateSlide"
                ></div>
              </div>
            </div>
          </div>
        </SlpColumn>
        <SlpColumn :cols="3" class="">
          <div v-if="data.graphic?.src" class="survey-quote-carousel__graphic">
            <div class="quotes-graphic">
              <nuxt-img
                :width="data.graphic.width ?? 1052"
                :height="data.graphic.height ?? 722"
                loading="lazy"
                :src="data.graphic.src"
                :alt="data.graphic.alt ?? 'quotes-graphic'"
                :data-aos="data.graphic.aos_animation ?? 'fade-up'"
                :data-aos-duration="data.graphic.aos_duration ?? 600"
                :data-aos-offset="data.graphic.aos_offset ?? 300"
                format="webp"
                quality="99"
              />
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.survey-quote-carousel {
  position: relative;
  overflow: hidden;
  margin: $spacing-64 0;
  padding: 0 !important;
  background-color: #171321;
  height: 817px;
  &__slide {
    padding: $spacing-96 0;
    width: 100%;
    height: 100%;
    position: relative;
    z-index: 2;
  }
  &__progressbar {
    display: block;
    margin-right: $spacing-24;
    height: 2px;
    background: #2e255c;
    z-index: 1;
    & > div {
      height: 100%;
      opacity: 0;
      width: 0;
      &.active {
        background-color: #67cfb7;
        opacity: 1;
      }
    }
    &:last-of-type {
      margin-right: 0;
    }
  }

  &__progressbar-container {
    display: flex;
    width: 100%;
    margin: $spacing-32 0 $spacing-48 0;

    @media (min-width: $breakpoint-md) {
      margin: $spacing-16 0 0;
      bottom: 0;
      position: absolute;
      left: 0;
      max-width: 300px;
    }
    @media (min-width: $breakpoint-lg) {
      margin: $spacing-16 0;
      max-width: 390px;
    }
  }
  &__graphic {
    position: relative;
    display: none;
    @media (min-width: $breakpoint-md) {
      display: block;
    }
  }
  &__background {
    position: absolute;
    top: 7%;
    left: 8%;
  }
  &__author {
    font-family: 'GitLab Mono';
    color: #67cfb7;
  }
  :deep b {
    font-weight: 600;
  }
  .quotes-graphic {
    mix-blend-mode: lighten;
    transform: translate3d(-620px, 0, 0);
    backface-visibility: hidden;
    -webkit-backface-visibility: hidden;
    z-index: 1;
    position: relative;
    opacity: 1;
    backface-visibility: hidden;
    perspective: 1000;
    will-change: transform, opacity;
  }
}
.slide-fade-enter-active {
  transition: all 0.5s;
}

.slide-fade-leave-active {
  transition: all 0.3s ease-in;
}

.slide-fade-enter,
.slide-fade-leave-to {
  transform: translateX(20px);
  opacity: 0;
  @media (prefers-reduced-motion) {
    opacity: 1;
    transform: none;
  }
}
.slide-fade-leave,
.slide-fade-enter-to {
  opacity: 1;
}
</style>
